<template>
  <div>
    <el-dialog
      :title="title"
      :close-on-click-modal="false"
	  draggable
      width="1500px"
      @close="close"
      @keyup.enter.native="doSubmit"
      v-model="visible">
      <el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="method==='view'"
               label-width="100px" @submit.native.prevent>

        <el-divider content-position="left"><i class="el-icon-document"></i> 基础信息</el-divider>
        <el-row :gutter="26">
          <el-col :span="12">
            <el-form-item label="领用编号" prop="collectNo">
              <el-input placeholder="自动生成" v-model="inputForm.collectNo" :disabled="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="经办人" prop="handledBy">
              <el-input v-model="inputForm.handledBy" :disabled="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="经办人部门" prop="handledByOffice">
              <SelectTree
                :disabled="true"
                ref="officeTree"
                :props="{
                  value: 'id',             // ID字段名
                  label: 'name',         // 显示名称
                  children: 'children'    // 子级字段名
                }"

                :url="`/system-server/sys/office/treeData?type=2`"
                :value="inputForm.handledByOffice"
                :accordion="true"
                size="default"
                @getValue="(value) => {inputForm.handledByOffice=value}"/>
              <!--            <el-input v-model="inputForm.handledByOffice" :disabled="true"></el-input>-->
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="领用时间" prop="collectDate" :rules="[{required: true, message:'请选择领用时间', trigger:'blur'}]">
              <el-date-picker
                v-model="inputForm.collectDate"
                type="date"
                value-format="YYYY-MM-DD"
                style="width: 100%"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注" prop="remarks">
              <el-input v-model="inputForm.remarks"
                        type="textarea"
                        :rows="5"
                        maxlength="500"
                        placeholder="请填写备注信息"
                        show-word-limit>
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
<!--method==='view' || this.formReadOnly-->
        <el-divider content-position="left"><i class="el-icon-document"></i>
          领用详情
          <el-button style="margin-left: 20px" type="primary" :disabled="true" @click="insertEvent('detail')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <el-col :span="24">
			  <vxe-table
				  border
				  show-footer
				  show-overflow
				  ref="detailTable"
				  class="vxe-table-element"
				  :data="inputForm.detailInfos"
				  style="margin-left: 5em"
				  highlight-current-row
				  :edit-config="{trigger: 'click', mode: 'row', showStatus: false, autoClear: true, icon: '-'}"
				  :edit-rules="validRules"
			  >
				  <vxe-table-column field="recipientAgent" title="领用人" :edit-render="{}" :rules="[{required: true, message:'请选择领用人', trigger:'blur'}]">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.recipientAgent" @focus="userPullListForm(scope.$rowIndex)"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column field="recipientOffice" title="领用人部门" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.recipientOffice" ></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column field="collectType" title="领用类型" :edit-render="{}" :rules="[{required: true, message:'请选择领用类型', trigger:'blur'}]">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.collectType" @focus="typePullForm(scope.$rowIndex)"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column field="goodsName" title="物品名称" :edit-render="{}" :rules="[{required: true, message:'请填写物品名称', trigger:'blur'}]">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.goodsName" @focus="openPurchasePageForm(scope.$rowIndex, scope.row)"></el-input>
					  </template>
				  </vxe-table-column>
				  <!--            <vxe-table-column field="surplusNumber" title="剩余数量" :edit-render="{}">-->
				  <!--              <template v-slot:edit="scope">-->
				  <!--                <el-input :disabled="true" v-model="scope.row.surplusNumber" maxlength="10"></el-input>-->
				  <!--              </template>-->
				  <!--            </vxe-table-column>-->
				  <vxe-table-column field="collectNumber" title="领用数量" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.collectNumber" @blur="scope.row.collectNumber = twoDecimalPlaces2(scope.row.collectNumber)" maxlength="10"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column field="company" title="单位" :edit-render="{}" :rules="[{required: true, message:'请填写单位', trigger:'blur'}]">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.company"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column field="remarks" title="备注" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.remarks" ></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column title="操作" width="180">
					  <template v-slot="scope">
						  <!--                <el-button :disabled='true' type="danger" v-if="method!=='view'" @click="removeEvent(scope.row,scope.$rowIndex,'detail')">删除</el-button>-->
						  <!--                <el-button :disabled='true' type="primary" v-if="method!=='view'" @click="sss(scope.$rowIndex)">上传附件</el-button>-->
						  <vxe-button status="primary" :disabled="false" @click="seeFileInfo(scope.$rowIndex)">查看文件详情</vxe-button>
					  </template>
				  </vxe-table-column>
			  </vxe-table>
		  </el-col>
        </el-row>

      </el-form>
      <PurchasePageForm  ref="purchasePageForm" @getProject="getContract"></PurchasePageForm>
      <!-- 附件 -->
      <MaterialManagementDialog ref="materialManagementDialog" @getUpload="getUpload"></MaterialManagementDialog>
      <UpLoadComponent ref="uploadComponent"></UpLoadComponent>
      <CwProgramPageForm ref="cwProgramPageForm" @getProgram="getProgram"></CwProgramPageForm>
      <MaterialTypePullForm ref="materialTypePullForm" @getProgramForType="getProgramForType"></MaterialTypePullForm>
      <UserPullForm ref="userPullForm" @getProgramForUser="getProgramForUser"></UserPullForm>
		<template #footer>
			<span class="dialog-footer">
			  <el-button @click="close()" icon="el-icon-circle-close">关闭</el-button>
			  <el-button type="primary" v-if="method != 'view'" @click="doSubmit()" icon="el-icon-circle-check" v-noMoreClick>确定</el-button>
			</span>
		</template>
    </el-dialog>
  </div>
</template>

<script>
  import PurchasePageForm from './PurchasePageForm'
  import CollectService from '@/api/materialManagement/CollectService'
  import SelectTree from '@/components/treeSelect/treeSelect.vue'
  import MaterialManagementDialog from '../file/MaterialManagementDialog'
  import CwProgramPageForm from '@/views/cw/reimbursementApproval/info/CwProgramPageForm'
  import MaterialTypePullForm from '../info/MaterialTypePullForm'
  import MaterialManagementService from '@/api/materialManagement/MaterialManagementService'
  import UpLoadComponent from '@/views/common/UpLoadComponent'
  import UserPullForm from '@/views/finance/invoice/UserPullForm'
  export default {
    data () {
      return {
        validRules: {
          recipientAgent: [
            {required: true, message: '领用人不能为空'}
          ],
          recipientOffice: [
            {required: true, message: '领用人部门不能为空'}
          ],
          collectType: [
            {required: true, message: '领用类型不能为空'}
          ],
          goodsName: [
            {required: true, message: '物品名称不能为空'}
          ],
          collectNumber: [
            {required: true, message: '领用数量不能为空'}
          ]
        },
        title: '',
        method: '',
        visible: false,
        loading: false,
        inputForm: {
          sign: '', // 管理员修改标记
          fileInfoLost: [],
          handledByOffice: '',
          handledBy: '',
          handledById: '',
          collectNo: '', // 领用编号
          userId: '',
          collectDate: '',
          remarks: '',
          detailInfos: [],
          // amountInfos: [],
          files: [] // 附件信息
        }
      }
    },
    CollectService: null,
    MaterialManagementService: null,
    created () {
      this.collectService = new CollectService()
      this.materialManagementService = new MaterialManagementService()
    },
    props: {
      businessId: {
        type: String,
        default: ''
      },
      formReadOnly: {
        type: Boolean,
        default: false
      },
      status: {
        type: String,
        default: ''
      }
    },
    components: {
      SelectTree,
      MaterialTypePullForm,
      CwProgramPageForm,
      MaterialManagementDialog,
      UpLoadComponent,
      UserPullForm,
      PurchasePageForm
    },
    computed: {
      bus: {
        get () {
          return this.businessId
        },
        set (val) {
          this.businessId = val
        }
      },
      name () {
        return this.$store.state.user.name
      },
      officeName () {
        return this.$store.state.user.office.name
      },
      userId () {
        return this.$store.state.user.id
      },
      recipientAgentId () {
        return this.$store.state.user.id
      },
      collectTypeId () {
        return ''
      }
    },
    methods: {
      init (method, id) {
        this.method = method
        this.inputForm = {
          sign: '', // 管理员修改标记
          fileInfoLost: [],
          handledByOffice: '',
          handledBy: this.$store.state.user.name,
          handledById: this.$store.state.user.id,
          collectNo: '', // 领用编号
          userId: this.$store.state.user.id,
          collectDate: new Date(),
          remarks: '',
          detailInfos: [],
          // amountInfos: [],
          files: [] // 附件信息
        }
        if (method === 'add') {
          this.title = `新建领用类型`
        } else if (method === 'edit') {
          this.inputForm.id = id
          this.title = '修改领用类型'
        } else if (method === 'view') {
          this.inputForm.id = id
          this.title = '查看领用类型'
        }
        this.visible = true
        this.loading = false
        this.$nextTick(() => {
          if (method === 'edit' || method === 'view') { // 修改或者查看
            this.loading = true
            this.$refs.inputForm.resetFields()
            this.collectService.findById(this.inputForm.id).then((data) => {
              this.inputForm = this.recover(this.inputForm, data)
              if (this.commonJS.isEmpty(this.inputForm.handledByOffice)) {
                this.inputForm.handledByOffice = this.$store.state.user.office.id
              }
              if (this.commonJS.isNotEmpty(data.collectDate)) {
                this.inputForm.collectDate = data.collectDate
              }
              if (this.commonJS.isNotEmpty(data.recipientAgentId)) {
                this.recipientAgentId = data.recipientAgentId
              }
              if (this.commonJS.isNotEmpty(data.collectTypeId)) {
                this.collectTypeId = data.collectTypeId
              }
              let i = this.inputForm.detailInfos.length
              for (let j = 0; j < i; j++) {
                if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
                  if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
                    this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
                  }
                }
              }
              this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'reimbursement')
              this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
              this.loading = false
            })
          }
        })
      },
      // 值改变事件
      changeValue () {
        let i = this.inputForm.detailInfos.length
        for (let j = 0; j < i; j++) {
          if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].surplusNumber)) {
            this.$message.error('请选择领用物品名称')
            return
          }
          if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].collectNumber)) {
            if (this.inputForm.detailInfos[j].surplusNumber < this.inputForm.detailInfos[j].collectNumber) {
              this.$message.error('领用数量不能大于剩余数量')
              return
            }
          }
        }
      },
      getProgramForUser (rows) {
        this.inputForm.detailInfos[this.indexRow].recipientAgentId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].recipientAgent = rows[0].name
        this.inputForm.detailInfos[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfos[this.indexRow].recipientOffice = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType (rows) {
        this.inputForm.detailInfos[this.indexRow].collectTypeId = rows.id
        this.inputForm.detailInfos[this.indexRow].collectType = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgram (rows) {
        this.inputForm.detailInfos[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].projectName = rows[0].name
        this.inputForm.detailInfos[this.indexRow].reportNumber = rows[0].reportNo
        this.indexRow = ''
        this.$forceUpdate()
      },
      getUpload (p, index) {
        p.then((list) => {
          // list为返回数据
          this.inputForm.detailInfos[index].fileInfoLost = list
          this.inputForm.detailInfos[index].fileNumber = list.length
          this.tableKeyClient = Math.random()
        })
      },
      twoDecimalPlaces2 (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`领用数量小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      // 采购人下拉弹窗
      userPullListForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm.init()
      },
      // footerMethod ({ columns, data }) {
      //   const footerData = [
      //     columns.map((column, columnIndex) => {
      //       if (columnIndex === 0) {
      //         return '商品总价'
      //       }
      //       if (['priceSum'].includes(column.property)) {
      //         // eslint-disable-next-line no-undef
      //         this.inputForm.tradeTotalPrice = XEUtils.sum(data, column.property)
      //         return XEUtils.sum(data, column.property)
      //       }
      //       return null
      //     })
      //   ]
      //   return footerData
      // },
      seeFileInfo (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload('view', this.inputForm.detailInfos[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      sss (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload(null, this.inputForm.detailInfos[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      // 采购类型下拉弹窗
      typePullForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.materialTypePullForm.init()
      },
      // 表单提交
      doSubmit () {
        this.$refs['inputForm'].validate((valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.loading = false
              this.inputForm.files = []
            }
            if (this.commonJS.isEmpty(this.inputForm.detailInfos)) {
              this.$message.error('至少填写一条领用详情信息')
              this.loading = false
              return
            } else {
              let i = this.inputForm.detailInfos.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].recipientAgent)) {
                  this.$message.error('领用详情第' + k + '行请选择领用人')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].collectType)) {
                  this.$message.error('领用详情第' + k + '行请选择领用类型')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].goodsName)) {
                  this.$message.error('领用详情第' + k + '行请选择物品名称')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].collectNumber)) {
                  this.$message.error('领用详情第' + k + '行请输入领用数量')
                  this.loading = false
                  return
                }
              }
            }
            this.inputForm.sign = '测试'
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.collectService.save(this.inputForm).then((data) => {
              // eslint-disable-next-line no-undef
              // callback(data.businessTable, data.businessId, this.inputForm)
              // this.$refs.inputForm.resetFields()
              this.$emit('refreshList')
              this.loading = false
              this.close()
            }).catch(() => {
              // this.$refs.inputForm.resetFields()
              this.loading = false
            })
          }
        })
      },
      close () {
        this.$refs.inputForm.resetFields()
        this.inputForm.detailInfos = []
        this.inputForm.amountInfos = []
        this.$refs.uploadComponent.clearUpload()
        this.visible = false
      },
      // 删除
      removeEvent (row, rowIndex, type) {
        if (type === 'detail') {
          this.$refs.detailTable.remove(row)
          this.inputForm.detailInfos.splice(rowIndex, 1)
        }
        if (type === 'amount') {
          this.$refs.amountTable.remove(row)
          // this.inputForm.amountInfos.splice(rowIndex, 1)
        }
      },
      // 新增
      async insertEvent (type) {
        if (type === 'detail') {
          await this.$refs.detailTable.insert().then((data) => {
            data.recipientAgent = this.$store.state.user.name
            data.recipientAgentId = this.recipientAgentId
            data.recipientOffice = this.officeName
            this.inputForm.detailInfos.push(data)
          })
        }
        if (type === 'amount') {
          await this.$refs.amountTable.insert().then((data) => {
            this.inputForm.amountInfos.push(data)
          })
        }
      },
      getContract (row) {
        this.inputForm.detailInfos[this.indexRow].surplusNumber = row.tradeNumber
        this.inputForm.detailInfos[this.indexRow].goodsName = row.tradeName
        // 去除重复的领用详情
        let i = this.inputForm.detailInfos.length
        for (let j = 0; j < i; j++) {
          console.log('进来了')
          for (let k = j + 1; k < i; k++) {
            if (this.inputForm.detailInfos[j].collectTypeId === this.inputForm.detailInfos[k].collectTypeId) {
              if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].goodsName) &&
                this.commonJS.isNotEmpty(this.inputForm.detailInfos[k].goodsName) && this.inputForm.detailInfos[j].goodsName === this.inputForm.detailInfos[k].goodsName) {
                // parseFloat(item.account).toFixed(2)
                this.inputForm.detailInfos.splice(k, 1)
                this.$message.warning(`同种领用类型的商品名称只能输入一条信息！`)
              }
            }
          }
        }
        this.indexRow = ''
        this.$forceUpdate()
      },
      openPurchasePageForm (rowIndex, row) {
        if (this.commonJS.isEmpty(row.collectType)) {
          this.$message.error('请选择领用类型')
          return
        }
        this.indexRow = rowIndex
        this.$refs.purchasePageForm.init(row.collectTypeId)
      }
    }
  }
</script>
